https://docs.n8n.io/learning-path/

这是一篇n8n入门指南，涵盖社区交流、注册安装、试用学习、自主搭建等多方面内容，帮助用户快速上手n8n： 1. **社区互动**：n8n社区活跃，用户可在社区论坛提问、提需求，在GitHub上报Bug、做贡献。 2. **注册与安装**：尚无账号的用户，可在n8n Cloud注册免费试用，或用Docker（推荐）、npm安装社区版，详情可查看“Choose your n8n” 。 3. **试用体验**：新手可通过快速入门指南搭建基础工作流程，包括超快速入门、详细入门教程，还有构建AI工作流程的指引 。 4. **课程学习**：n8n提供视频课程和文本课程。视频课程分为初学者和高级课程，分别讲解基础和复杂功能；文本课程分初、中级，用户学习同时构建复杂工作流程，还能获得徽章和头像。 5. **自主搭建**：探索n8n的多种自托管选项，热门方案有在DigitalOcean和亚马逊云服务上进行搭建 。 6. **自定义节点**：若找不到特定应用或服务的节点，用户可自行构建并分享。可参考npm网站他人成果，学习构建声明式节点和自定义节点（YouTube视频教程） 。 7. **资讯关注**：通过版本说明了解新功能和Bug修复情况，还可在Twitter/X、Discord等社交平台关注n8n 。

![[Pasted image 20250204021453.png]]

- - 新手引导概述
        
        - 本指南助力用户开启n8n学习之旅
            
        - 可依需求选择相关学习内容
            
    - 社区互动渠道
        
        - 在社区论坛提问和提功能需求
            
        - 在GitHub上报Bug和贡献代码
            
    - 搭建n8n环境
        
        - 注册n8n Cloud免费试用账号
            
        - 用Docker或npm安装社区版
            
    - 上手体验操作
        
        - 通过快速入门指南搭建基础流程
            
        - 尝试搭建AI工作流程
            
    - 课程学习资源
        
        - 视频课程涵盖初高级知识要点
            
        - 文本课程边学边搭建复杂流程
            
    - 自主搭建方案
        
        - 在DigitalOcean上托管n8n
            
        - 在亚马逊云服务上托管n8n
            
    - 自定义节点构建
        
        - 自行构建节点并分享给社区
            
        - 学习构建声明式风格的节点
            
    - 关注更新动态
        
        - 从发布说明了解新功能和修复
            
        - 在多平台关注n8n官方动态


## 学习路径

https://docs.n8n.io/learning-path/#set-up-your-n8n

这是n8n的新手引导网页，为用户提供了入门教程和资源，帮助其快速上手使用n8n。 
1. **社区支持**：n8n社区活跃，用户能在社区论坛提问、提功能需求，也可在GitHub上报Bug和贡献代码。
2. **基础准备**：没有账号的用户，可以注册n8n Cloud免费试用版，或用Docker（推荐） 、npm安装社区版。 
3. **快速上手**：通过快速入门指南搭建基础工作流，有“非常快速的快速入门”“较长的介绍”以及“在n8n中构建AI工作流”等内容。 
4. **课程学习**：包含视频课程和文本课程。视频课程分初级和高级，分别涵盖n8n基础及复杂工作流等内容；
	- The [Beginner](https://www.youtube.com/playlist?list=PLlET0GsrLUL59YbxstZE71WszP3pVnZfI) course covers the basics of n8n.
	- The [Advanced](https://www.youtube.com/playlist?list=PLlET0GsrLUL5bxmx5c1H1Ms_OtOPYZIEG) course covers more complex workflows, more technical nodes, and enterprise features
6. 文本课程可在构建复杂工作流同时学习关键概念，完成还能获徽章和头像。 
	- [Level 1: Beginner Course](https://blog.n8n.io/announcing-the-n8n-certification-course-for-beginners-level-1/)
	- [Level 2: Intermediate Course](https://blog.n8n.io/announcing-course-level-two/)
7. **自主托管**：可探索多种自托管选项，热门选择有在DigitalOcean和亚马逊云服务上托管。 
8. **节点构建**：若找不到特定应用或服务的节点，可自行构建并分享，还能参考npm网站上他人的成果。 
9. **动态关注**：通过版本说明了解新功能和Bug修复情况，还能在Twitter/X、Discord等社交平台关注n8n。
![[Pasted image 20250204022601.png]]