如果我的诉求是要求住建委介入调查取证，并要求开发商提供相关销售记录，并要求住建委给于书面回复。我要求给于书面回复的诉求的背后的目的是为了给自己后续不论是起诉开发商违约还是起诉住建委行政不作为，积累对自己有利的证据，当然这只是我的一厢情愿，那么站在住建委的立场，对于我的诉求，他们更可能的对应之策是什么

基于 7 个搜索来源

![](https://p3-search.byteimg.com/img/labis/a540057a5b2cb28d14661661546cb71c~noop.jpeg)

站在住建委的立场，对于这样的诉求，可能会采取以下对应之策：

  

- **核实诉求合理性与合法性**
    - **审查法定职责**：确认自身是否具有介入调查开发商销售记录的法定职责。若有明确法律依据，会进一步考虑具体操作流程和权限范围；若职责不明确，可能会依据相关规定进行研究判断，或者与上级部门沟通请示。
    - **判断诉求依据**：审查业主提供的材料和理由，看是否足以支撑要求介入调查的请求。例如，是否有初步证据表明开发商存在违规行为或可能损害业主权益的情况，若证据不足，可能会要求业主补充相关材料。
- **启动调查程序**
    - **要求开发商配合**：如果决定介入调查，会向开发商发出正式通知，要求其提供相关销售记录及其他与调查事项有关的材料，并明确提供的期限和要求。同时，告知开发商若不配合调查可能面临的法律后果。
    - **展开实地调查**：住建委可能会安排工作人员对项目现场进行实地查看，了解项目的实际建设、销售情况，核实是否存在与销售记录不符或其他违规行为。例如，查看房屋的交付情况、销售价格是否符合备案要求等。
    - **收集多方证据**：除了开发商提供的材料和实地调查外，还可能会收集其他相关证据，如业主的购房合同、付款凭证、与开发商的沟通记录等，以全面了解情况。
- **与业主保持沟通**
    - **告知进展情况**：在调查过程中，住建委可能会定期与业主沟通，告知其调查的进展情况，包括已经采取的措施、发现的问题以及下一步的工作计划等，让业主了解其诉求正在得到处理。
    - **听取业主意见**：继续听取业主的意见和建议，解答业主的疑问，对于业主提供的新线索或证据，及时进行核实和处理。
- **作出书面回复**
    - **回复内容全面准确**：根据调查结果，以书面形式回复业主。回复内容会明确说明调查的过程、发现的事实、是否存在开发商违规行为以及住建委采取的措施或下一步打算等。如果开发商存在违规行为，会告知业主相应的处理结果和依据；如果未发现违规行为，也会说明理由和依据。
    - **法律依据充分**：在书面回复中，会引用相关的法律法规和政策文件，以支持住建委的调查结论和处理意见，确保回复具有合法性和权威性。
    - **语言规范严谨**：书面回复的语言会规范、严谨，避免使用模糊不清或容易引起误解的表述，确保业主能够准确理解住建委的立场和处理结果。

  

如果在调查过程中发现业主的诉求不合理或缺乏事实依据，住建委也会在书面回复中详细说明理由，并向业主做好解释工作，同时可能会建议业主通过其他合法途径解决问题，如与开发商协商、通过仲裁或诉讼解决纠纷等。

你说的这个住建委的对应之策对我来说求之不得，但是现实中往往不够积极主动，甚至可能找各种理由推诿或者拖延，所以我需要研判他们可能采取的对我不利的策略来对应我要求他们提供书面回复并积极介入的诉求

如果住建委存在不够积极主动、推诿或拖延的情况，可能会采取以下一些对你不利的策略，你可以提前有所准备并思考应对方法：

  

- **以程序或材料为由拖延**
    - **要求补充材料**：住建委可能会以你提交的材料不齐全或不符合要求为由，要求你补充各种证明材料。这可能会导致时间延长，而且如果你未能及时补充，他们可能会以此为由搁置调查。
    - **强调程序合规**：强调需要遵循严格的内部程序，例如需要多个部门审批、会签等，导致处理过程缓慢。或者以需要先进行内部研究、讨论为由，不立即开展调查工作。
    - **应对方法**：在提交诉求时，尽可能确保材料齐全、规范，并保留好所有提交材料的清单和回执。同时，了解住建委的相关程序规定，对于合理的程序要求予以配合，但对于不合理的拖延，可以依据规定要求其明确时间节点，并以书面形式告知你。
- **模糊处理或回避关键问题**
    - **给出模糊回复**：在书面回复中，使用模糊不清的语言，对关键问题不做明确答复，或者只给出一些笼统的说明，不涉及具体的调查结果和处理措施。例如，只是说 “正在调查中” 或 “已关注到相关问题”，但没有具体说明调查的进展和下一步计划。
    - **回避核心诉求**：对于你要求调查的核心问题，如开发商的具体违规行为、销售记录的真实性等，避而不谈，转而强调一些无关紧要的方面，或者将问题归咎于其他因素，如市场环境、政策变化等。
    - **应对方法**：收到回复后，仔细研读内容，对于模糊或回避的问题，以书面形式再次向住建委提出明确的疑问，要求其给予具体、准确的答复。同时，可以引用相关法律法规和政策文件，说明你所关注问题的重要性和关联性，要求其依法履行职责。
- **将责任推给其他部门或主体**
    - **指出非自身职责**：住建委可能会声称你所反映的问题不属于其职责范围，而应归其他部门管辖，如市场监管部门、税务部门等，从而拒绝介入调查。即使问题可能涉及多个部门，也可能会以职责分工为由，不主动协调处理。
    - **强调开发商责任**：强调开发商是独立的市场主体，住建委只能进行宏观监管，对于具体的合同纠纷、销售行为等，应由业主与开发商自行协商解决，或者通过司法途径解决，以此来减少自身的介入程度。
    - **应对方法**：提前了解相关部门的职责划分，对于住建委声称不属于其职责的情况，提供充分的法律依据和事实证据，证明该问题确实在其监管范围内。如果涉及多个部门，要求住建委履行协调职责，或者建议其与相关部门联合开展调查。同时，向住建委说明业主与开发商协商和司法途径存在的困难，强调行政监管介入的必要性。
- **消极对待调查工作**
    - **调查不深入全面**：虽然开展了调查，但只是形式上走过场，没有深入核实相关证据，对开发商提供的材料不做仔细审查，或者不主动收集其他可能存在的证据，导致无法发现真正的问题。
    - **不积极跟进处理**：即使发现了开发商存在一些问题，也不采取有效的措施督促其整改，或者对整改情况不进行跟踪检查，导致问题得不到实质性解决。
    - **应对方法**：如果发现住建委调查不深入，你可以主动收集相关证据并提供给他们，同时要求其对这些证据进行核实。对于整改情况，定期向住建委了解进展，并要求其提供书面的整改报告。如果住建委仍然消极对待，你可以向上级主管部门投诉，或者通过信息公开申请等方式，获取调查和处理的相关信息，以监督其履行职责。